//#extension GL_OES_EGL_image_external : require
precision mediump float;

uniform int stickerType;

uniform int faceNum;
uniform vec2 baseImgWH;

uniform vec2 angle0;
uniform vec2 angle1;
uniform vec2 angle2;
uniform vec2 angle3;
uniform vec2 angle4;

uniform vec2 alignPoint0;
uniform vec2 alignPoint1;
uniform vec2 alignPoint2;
uniform vec2 alignPoint3;
uniform vec2 alignPoint4;

uniform vec4 StickerInfo0;
uniform vec4 StickerInfo1;
uniform vec4 StickerInfo2;
uniform vec4 StickerInfo3;
uniform vec4 StickerInfo4;

varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture2;

vec2 CalcRealNormCoord( vec2 Angle,vec2 Align, vec4 stickerInfo, vec2 frameCoord ){
    vec2 transCoord = vec2(0.0, 0.0);           /* 逆旋转后坐标 */
    vec2 rotatedAlign = vec2(0.0, 0.0);         /* 绑定点坐标，与上一步相同，进行旋转计算 */

    transCoord.x = Angle.x * frameCoord.x + Angle.y * frameCoord.y;
    transCoord.y = Angle.x * frameCoord.y - Angle.y * frameCoord.x;

    rotatedAlign.x = Angle.x * Align.x + Angle.y * Align.y;
    rotatedAlign.y = Angle.x * Align.y - Angle.y * Align.x;

    transCoord = transCoord + stickerInfo.zw - rotatedAlign;
    vec2 normCoord = vec2( transCoord.x / stickerInfo.x, transCoord.y / stickerInfo.y );

    return normCoord;
}

vec4 getNewColor( sampler2D Texture, vec2 normCoord ){
    vec4 textureColor = texture2D(Texture, normCoord);
    float alpha = textureColor.w;
    vec4 finalColor = gl_FragColor * ( 1.0 - alpha ) + textureColor * alpha;
    return finalColor;
}


void main() {
    gl_FragColor = vec4(0.0,0.0,0.0,0.0);

    float in_FrameW = baseImgWH.x;
    float in_FrameH = baseImgWH.y;

    vec2 in_NormCoord = vec2(0.0, 0.0);
    vec2 in_FrameCoord;
    in_FrameCoord = vec2( textureCoordinate.x * in_FrameW, textureCoordinate.y * in_FrameH );

    if(faceNum>0) {
        in_NormCoord = CalcRealNormCoord( angle0, alignPoint0, StickerInfo0,in_FrameCoord );
        if (in_NormCoord.x > 0.0 && in_NormCoord.y > 0.0 && in_NormCoord.x < 1.0 && in_NormCoord.y < 1.0) {
            gl_FragColor = getNewColor( inputImageTexture2, in_NormCoord );
        }
    }
    if(stickerType==3)
        return;

    if(faceNum>1) {
        in_NormCoord = CalcRealNormCoord( angle1, alignPoint1, StickerInfo1,in_FrameCoord );
        if (in_NormCoord.x > 0.0 && in_NormCoord.y > 0.0 && in_NormCoord.x < 1.0 && in_NormCoord.y < 1.0) {
            gl_FragColor = getNewColor( inputImageTexture2, in_NormCoord );
        }
    }

    if(faceNum>2) {
        in_NormCoord = CalcRealNormCoord( angle2, alignPoint2, StickerInfo2,in_FrameCoord );
        if (in_NormCoord.x > 0.0 && in_NormCoord.y > 0.0 && in_NormCoord.x < 1.0 && in_NormCoord.y < 1.0) {
            gl_FragColor = getNewColor( inputImageTexture2, in_NormCoord );
        }
    }

    if(faceNum>3) {
        in_NormCoord = CalcRealNormCoord( angle3, alignPoint3, StickerInfo3,in_FrameCoord );
        if (in_NormCoord.x > 0.0 && in_NormCoord.y > 0.0 && in_NormCoord.x < 1.0 && in_NormCoord.y < 1.0) {
            gl_FragColor = getNewColor( inputImageTexture2, in_NormCoord );
        }
    }

    if(faceNum>4) {
        in_NormCoord = CalcRealNormCoord( angle4, alignPoint4, StickerInfo4, in_FrameCoord );
        if (in_NormCoord.x > 0.0 && in_NormCoord.y > 0.0 && in_NormCoord.x < 1.0 && in_NormCoord.y < 1.0) {
            gl_FragColor = getNewColor( inputImageTexture2, in_NormCoord );
        }
    }


}