precision mediump float;

uniform sampler2D inputImageTexture;
uniform float texelWidth; 
uniform float texelHeight; 
 
const  int GAUSSIAN_SAMPLES = 9;
const float GAUSSIAN_LENGTH = 9.0;
 
varying  vec2 textureCoordinate; 

void main() 
{
    //float blurAlpha[]= {0.05, 0.09, 0.12, 0.15, 0.18, 0.15,0.12, 0.09, 0.05};
    float blurAlpha[9];

    blurAlpha[0] = 0.05;  blurAlpha[1] = 0.09;  blurAlpha[2] = 0.12;
    blurAlpha[3] = 0.15;  blurAlpha[4] = 0.18;  blurAlpha[5] = 0.15;
    blurAlpha[6] = 0.12;  blurAlpha[7] = 0.09;  blurAlpha[8] = 0.05;

	vec3 sum = vec3(0.0); 
    vec4 fragColor=texture2D(inputImageTexture,textureCoordinate); 
	
	// Calculate the positions for the blur 
	int multiplier = 0; 
	vec2 blurStep; 
    vec2 singleStepOffset = vec2(texelWidth, texelHeight); 
     
	for (int i = 0; i < GAUSSIAN_SAMPLES; i++) 
    { 
		multiplier = (i - ((GAUSSIAN_SAMPLES - 1) / 2)); 
        // Blur in x (horizontal) 
        blurStep = float(multiplier) * singleStepOffset;
		sum += texture2D(inputImageTexture, textureCoordinate.xy + blurStep).rgb * blurAlpha[i] ;
	} 
	 
	//sum /= GAUSSIAN_LENGTH;
 
	gl_FragColor = vec4(sum,fragColor.a); 
}