precision mediump float;

uniform sampler2D midTexture;
uniform float texelWidth; 
uniform float texelHeight; 

varying vec2 textureCoordinate;
varying vec4 vPos;

void main() 
{ 
    vec4 fragColor=texture2D(midTexture,textureCoordinate); 
	vec4 blurColor = vec4(0.0, 0.0, 0.0, 0.0);
    vec2 singleStepOffset = vec2(texelHeight, texelWidth); 
	float blurWeight = 0.0;
	
	float randOffset = fract(sin(dot(vPos, vec4(12.9898, 78.233, 151.7182, 0.0))) * 43758.5453);
	for (float t = -11.0; t < 11.0; t++)
    { 
		float uvRate = (t + randOffset - 0.5) * 0.33333;
		float weight = 1.0 - abs(uvRate);
		vec4 color = texture2D(midTexture, textureCoordinate + singleStepOffset * uvRate);
		blurColor  += color * weight;
		blurWeight += weight;
	}
	blurColor /= blurWeight;
	gl_FragColor = vec4(blurColor.rgb,fragColor.a); 
}