//squareface
precision highp float;
varying lowp vec2 textureCoordinate;

uniform sampler2D map_texture;

uniform lowp float ScreenWidth; // p_eyeRight
uniform lowp float ScreenHeight; // p_eyeLeft

uniform lowp vec2 location0; // p_eyeRight
uniform lowp vec2 location1; // p_eyeLeft
uniform lowp vec2 location2; // p_browRight
uniform lowp vec2 location3; // p_browLeft
uniform lowp vec2 location4; // p_noseTip
uniform lowp vec2 location5; // p_noseLeg
uniform lowp vec2 location6; // p_mouthRight
uniform lowp vec2 location7; // p_mouthLeft
uniform lowp vec2 location8; // p_mouthTop
uniform lowp vec2 location9; // p_mouthBottom
uniform lowp vec2 location10;// p_chin
uniform lowp vec2 location11;// p_faceRight1
uniform lowp vec2 location12;// p_faceLeft1
uniform lowp vec2 location13;// p_faceRight2
uniform lowp vec2 location14;// p_faceLeft2
uniform lowp vec2 location15;// p_faceRight3
uniform lowp vec2 location16;// p_faceLeft3
uniform lowp vec2 location17;// p_faceRight4
uniform lowp vec2 location18;// p_faceLeft4
uniform lowp vec2 location19;// p_faceRight5
uniform lowp vec2 location20;// p_faceLeft5
uniform lowp vec2 location21;// p_faceRight6
uniform lowp vec2 location22;// p_faceLeft6
uniform lowp vec2 location23;// p_faceRight7
uniform lowp vec2 location24;// p_faceLeft7

vec4 blendNormal(vec4 c1, vec4 c2) {
vec4 outputColor;
outputColor.r = c1.r + c2.r * c2.a * (1.0 - c1.a);
outputColor.g = c1.g + c2.g * c2.a * (1.0 - c1.a);
outputColor.b = c1.b + c2.b * c2.a * (1.0 - c1.a);
outputColor.a = c1.a + c2.a * (1.0 - c1.a);
return outputColor;
}


vec2 flowAway(vec2 realCoord, vec2 scrSize, vec2 facePoint, vec2 angle, vec2 weiyi, vec2 faceSize, vec2 pngSize, float radius, float amp, vec2 originPosition)
{
vec2 facePointA = facePoint * scrSize;
vec2 facePointAfter = vec2(0.0);
facePointAfter.x = angle.y * facePointA.x + angle.x * facePointA.y;
facePointAfter.y = angle.y * facePointA.y - angle.x * facePointA.x;
facePointAfter += weiyi;
facePointAfter /= faceSize;

vec2 direction = facePointAfter - originPosition;
float lengthA = length(direction);
float lengthB = min(lengthA, radius);
direction *= amp * lengthB / lengthA;
float infect = distance(realCoord*pngSize,originPosition*pngSize)/radius;
infect = clamp(1.0-infect, 0.0, 1.0);
infect  = pow(infect, 2.0);

return direction * infect;
}

vec2 faceStretch(vec2 textureCoord, vec2 originPosition, vec2 targetPosition, float radius, float amp, float curve)
{
vec2 direction = targetPosition - originPosition;
float lengthA = length(direction);
float lengthB = min(lengthA, radius);
direction *= amp * lengthB / lengthA;
float infect = distance(textureCoord, originPosition)/radius;
infect = clamp(1.0-infect,0.0,1.0);
infect = pow(infect, curve);

return direction * infect;
}

void main(){

gl_FragColor = texture2D(map_texture,textureCoordinate);

if(location0.x < 0.01 && location1.x < 0.01)
{
gl_FragColor = texture2D(map_texture,textureCoordinate);
return;
}


float x_axis = ScreenWidth;
float y_axis = ScreenHeight;


vec2 textureCoord = vec2(textureCoordinate.x * x_axis, textureCoordinate.y * y_axis);
//==========
float faceWidth = distance(vec2(location0.x * x_axis, location0.y * y_axis), vec2(location1.x * x_axis, location1.y * y_axis));
vec2 centerPoint = vec2(location9.x * x_axis, location9.y * y_axis);
vec2 centerPoint2 = vec2(location8.x * x_axis, location8.y * y_axis);

vec2 targetLeft = vec2(location12.x * x_axis, location10.y * y_axis);
vec2 targetRight = vec2(location11.x * x_axis, location10.y * y_axis);

vec2 targetLeft0 = vec2(location12.x * x_axis, location10.y * y_axis);
vec2 targetRight0 = vec2(location11.x * x_axis, location10.y * y_axis);
float radius = 100.0;
float amp = 1.0;


radius = faceWidth*0.5;
vec2 faceLeft5 = vec2(location18.x*x_axis, location18.y*y_axis);
targetLeft = centerPoint + (faceLeft5 - centerPoint) * 1.2;
vec2 vectorfaceLeft5 = faceStretch(textureCoord, faceLeft5, targetLeft, radius, amp, 2.0);
vec2 faceRight5 = vec2(location17.x*x_axis, location17.y*y_axis);
targetRight = centerPoint + (faceRight5 - centerPoint) * 1.2;
vec2 vectorfaceRight5 = faceStretch(textureCoord, faceRight5, targetRight, radius, amp, 2.0);

radius = faceWidth*0.7;
vec2 faceLeftplus5 = targetLeft;
targetLeft = centerPoint + (faceLeft5 - centerPoint) * 1.3;
vec2 vectorfaceLeftplus5 = faceStretch(textureCoord, faceLeftplus5, targetLeft, radius, amp, 3.0);
vec2 faceRightplus5 = targetRight;
targetRight = centerPoint + (faceRight5 - centerPoint) * 1.3;
vec2 vectorfaceRightplus5 = faceStretch(textureCoord, faceRightplus5, targetRight, radius, amp, 3.0);

radius = faceWidth*1.1;
vec2 faceLeftplus6 = targetLeft;
targetLeft = centerPoint + (faceLeft5 - centerPoint) * 1.4;
vec2 vectorfaceLeftplus6 = faceStretch(textureCoord, faceLeftplus6, targetLeft, radius, amp, 3.3);
vec2 faceRightplus6 = targetRight;
targetRight = centerPoint + (faceRight5 - centerPoint) * 1.4;
vec2 vectorfaceRightplus6 = faceStretch(textureCoord, faceRightplus6, targetRight, radius, amp,3.3);


radius = faceWidth*1.4;
vec2 chin = vec2(location10.x * x_axis, location10.y * y_axis);;
vec2 targetchin = centerPoint + (chin - centerPoint) * 0.4;
vec2 chinplus = faceStretch(textureCoord, chin, targetchin, radius, amp, 2.0);


radius = faceWidth*1.1;
vec2 faceLeftplus7 = vec2(location16.x*x_axis, location16.y*y_axis);
targetLeft = centerPoint + (faceLeftplus7 - centerPoint) * 1.05;
vec2 vectorfaceLeftplus7 = faceStretch(textureCoord, faceLeftplus7, targetLeft, radius, amp, 2.0);
vec2 faceRightplus7 = vec2(location15.x*x_axis, location15.y*y_axis);
targetRight = centerPoint + (faceRightplus7 - centerPoint) * 1.05;
vec2 vectorfaceRightplus7 = faceStretch(textureCoord, faceRightplus7, targetRight, radius, amp,2.0);


radius = faceWidth*1.2;
vec2 faceLeftplus8 = vec2(location1.x*x_axis, location1.y*y_axis);
vec2 faceLeftplus9 = centerPoint2 + (faceLeftplus8 - centerPoint2) * 2.2;
targetLeft = centerPoint2 + (faceLeftplus8 - centerPoint2) * 2.4;
vec2 vectorfaceLeftplus9 = faceStretch(textureCoord, faceLeftplus9, targetLeft, radius, amp, 2.0);
vec2 faceRightplus8 = vec2(location0.x*x_axis, location0.y*y_axis);
vec2 faceRightplus9 = centerPoint2 + (faceRightplus8 - centerPoint2) * 2.2;
targetRight = centerPoint2 + (faceRightplus8 - centerPoint2) * 2.4;
vec2 vectorfaceRightplus9 = faceStretch(textureCoord, faceRightplus9, targetRight, radius, amp,2.0);


radius = faceWidth*1.1;
vec2 faceLeftplus78 = vec2(location7.x*x_axis, location7.y*y_axis);
targetLeft = centerPoint2 + (faceLeftplus78 - centerPoint2) * 1.2;
vec2 vectorfaceLeftplus78 = faceStretch(textureCoord, faceLeftplus78, targetLeft, radius, amp, 2.0);
vec2 faceRightplus78 = vec2(location6.x*x_axis, location6.y*y_axis);
targetRight = centerPoint2 + (faceRightplus78 - centerPoint2) * 1.2;
vec2 vectorfaceRightplus78 = faceStretch(textureCoord, faceRightplus78, targetRight, radius, amp,2.0);





//==========
radius = faceWidth*0.25;
float a = 0.8;
vec2 diffusePosition = vec2(location0.x*x_axis, location0.y*y_axis);
float infect3 = distance(textureCoord, diffusePosition)/radius;
infect3 = clamp(infect3,0.0,1.0);
infect3 = a * infect3 * (infect3 - 1.0) + 1.0;
//==========
vec2 diffusePosition2 = vec2(location1.x*x_axis, location1.y*y_axis);
float infect4 = distance(textureCoord, diffusePosition2)/radius;
infect4 = clamp(infect4,0.0,1.0);
infect4 = a * infect4 * (infect4 - 1.0) + 1.0;
//==========


radius = faceWidth*1.9;
vec2 nose = centerPoint2;
vec2 targetnose = centerPoint2 + (centerPoint - centerPoint2) * 0.3;
vec2 noseplus = faceStretch(textureCoord, nose, targetnose, radius, amp, 2.0);


//====================================
vec2 textureCoord_new = textureCoord - vectorfaceLeft5;
textureCoord_new = textureCoord_new - vectorfaceRight5;
textureCoord_new = textureCoord_new - vectorfaceLeftplus5;
textureCoord_new = textureCoord_new - vectorfaceRightplus5;
textureCoord_new = textureCoord_new - vectorfaceLeftplus6;
textureCoord_new = textureCoord_new - vectorfaceRightplus6;
textureCoord_new = textureCoord_new - chinplus;
textureCoord_new = textureCoord_new - vectorfaceLeftplus7;
textureCoord_new = textureCoord_new - vectorfaceRightplus7;
textureCoord_new = textureCoord_new - vectorfaceLeftplus9;
textureCoord_new = textureCoord_new - vectorfaceRightplus9;
textureCoord_new = textureCoord_new - vectorfaceLeftplus78;
textureCoord_new = textureCoord_new - vectorfaceRightplus78;

textureCoord_new = diffusePosition + (textureCoord_new - diffusePosition)*infect3;
textureCoord_new = diffusePosition2 + (textureCoord_new - diffusePosition2)*infect4;

textureCoord_new = textureCoord_new - noseplus;


vec2 coordUse = vec2(textureCoord_new.x / x_axis, textureCoord_new.y / y_axis);
gl_FragColor = texture2D(map_texture,coordUse);

/*
if(distance(diffusePosition, textureCoord)< 10.0)
gl_FragColor = vec4(1.0,1.0,0.0,1.0);
if(distance(diffusePosition2, textureCoord)< 10.0)
gl_FragColor = vec4(1.0,1.0,0.0,1.0);
*/
//====================================


}

